--- ../boot.cmd	2014-03-27 23:23:15.469016382 +0000
+++ boot.cmd-62	2014-03-28 08:17:19.000000000 +0000
@@ -1,5 +1,5 @@
-# mkimage -A arm -O linux -T script -C none -a 0 -e 0 -n "a-b-c on Thu Mar 27 23:23:11 GMT 2014" -d boot.cmd boot.scr
-echo Welcome to a-b-c 0.59.
+# mkimage -A arm -O linux -T script -C none -a 0 -e 0 -n "a-b-c on Thu Mar 27 19:32:20 GMT 2014" -d boot.cmd boot.scr
+echo Welcome to a-b-c 0.62.
 echo
 
 
@@ -9,6 +9,7 @@
 
 if test -n \'$findfdt\'; then echo "Using findfdt to set u_dtb"; run findfdt; fi
 
+setenv bootm_size 0x20000000
 setenv config_default 'u_k_addr=""; u_ramfs_addr=""; u_dtb_addr=""; skip_dtb=""; pass_dtb=1; u_dtb="$fdtfile"; u_extraargs=""; u_iodevs="mmc usb scsi sata ide"; u_fs="ext2 fat"; u_boot=bootm; u_devpart="0:1 0:2"; u_dir="/ /boot/"; systemd_args=""'
 run config_default
 
@@ -39,7 +40,7 @@
 setenv config_midway 'echo Configuring for midway;run config_calxeda; u_dtb=ecx-2000.dtb'
 ca8=config_midway
 setenv c8 "run config_midway; run showdefs"
-setenv config_imx 'echo Configuring for imx;run config_default; u_extraargs="\$u_extraargs console=\$console"; u_k_addr=0x14000000; u_ramfs_addr=0x32000000; u_dtb_addr=0x12000000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs=ext2; u_boot=bootz; u_devpart="0:1 0:2 1:1 1:2"'
+setenv config_imx 'echo Configuring for imx;run config_default; u_extraargs="\$u_extraargs console=\$console,115200"; u_k_addr=0x14000000; u_ramfs_addr=0x32000000; u_dtb_addr=0x12000000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs=ext2; u_boot=bootz; u_devpart="0:1 0:2 1:1 1:2"'
 ca9=config_imx
 setenv c9 "run config_imx; run showdefs"
 setenv config_utilite 'echo Configuring for utilite;run config_imx; u_boot=bootm; skip_dtb=1; pass_dtb=""; u_iodevs="sata mmc usb"'
@@ -48,27 +49,30 @@
 setenv config_wandboard 'echo Configuring for wandboard;run config_imx; setenv u_dtb \$fdt_file'
 ca11=config_wandboard
 setenv c11 "run config_wandboard; run showdefs"
+setenv config_cubox 'echo Configuring for cubox;run config_imx; setenv u_dtb \$fdt_file'
+ca12=config_cubox
+setenv c12 "run config_cubox; run showdefs"
 setenv config_tegra 'echo Configuring for tegra;run config_default; u_extraargs="\$u_extraargs console=ttyS0,115200n8"; u_k_addr=4080000; u_ramfs_addr=4800000; u_dtb_addr=4000000; skip_dtb=""; pass_dtb=1; u_iodevs="usb mmc"; u_fs=ext2; u_boot=bootz; setenv fdt_high 0x2C000000; setenv initrd_high 0x2C000000; u_devpart="0:1 0:2 1:1 1:2"; u_dtb=\${soc}-\${board}.dtb'
-ca12=config_tegra
-setenv c12 "run config_tegra; run showdefs"
-setenv config_am33xx 'echo Configuring for am33xx;run config_default; u_k_addr=0x80300000; u_ramfs_addr=0x82000000; u_dtb_addr=0x81600000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs="ext4 ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO0,115200n8"; u_dir="/boot/ /"; run findfdt; u_dtb="\$fdtfile"'
-ca13=config_am33xx
-setenv c13 "run config_am33xx; run showdefs"
-setenv config_omap3 'echo Configuring for omap3;run config_default; u_k_addr=0x80300000; u_ramfs_addr=0x82000000; u_dtb_addr=0x81600000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs="ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO2,115200n8"; u_dir="/boot/ /"; run findfdt; u_dtb=\$fdtfile'
-ca14=config_omap3
-setenv c14 "run config_omap3; run showdefs"
-setenv config_omap4 'echo Configuring for omap4;run config_default; u_k_addr=0x80300000; u_ramfs_addr=0x81600000; u_dtb_addr=0x81F00000; skip_dtb=""; pass_dtb=1 u_iodevs="mmc usb"; u_fs="ext4 ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO2,115200n8"; u_dir="/boot/ /"; run findfdt; u_dtb=\$fdtfile'
-ca15=config_omap4
-setenv c15 "run config_omap4; run showdefs"
-setenv config_omap5 'echo Configuring for omap5;run config_default; u_k_addr=0x80300000; u_ramfs_addr=0x81600000; u_dtb_addr=0x825f0000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs="ext4 ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO2,115200n8"; u_dir="/boot/ /"; setenv fdt_high 0x84000000; run findfdt; u_dtb=\$fdtfile'
-ca16=config_omap5
-setenv c16 "run config_omap5; run showdefs"
+ca13=config_tegra
+setenv c13 "run config_tegra; run showdefs"
+setenv config_am33xx 'echo Configuring for am33xx;run config_default; u_k_addr=0x88080000; u_ramfs_addr=0x82000000; u_dtb_addr=0x88000000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs="ext4 ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO0,115200n8"; u_dir="/boot/ /"; run findfdt; u_dtb="\$fdtfile"'
+ca14=config_am33xx
+setenv c14 "run config_am33xx; run showdefs"
+setenv config_omap3 'echo Configuring for omap3;run config_default; u_k_addr=0x88080000; u_ramfs_addr=0x80000000; u_dtb_addr=0x88000000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs="ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO2,115200n8"; u_dir="/boot/ /"; run findfdt; u_dtb=\$fdtfile'
+ca15=config_omap3
+setenv c15 "run config_omap3; run showdefs"
+setenv config_omap4 'echo Configuring for omap4;run config_default; u_k_addr=0x88080000; u_ramfs_addr=0x88000000; u_dtb_addr=0x81F00000; skip_dtb=""; pass_dtb=1 u_iodevs="mmc usb"; u_fs="ext4 ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO2,115200n8"; u_dir="/boot/ /"; run findfdt; u_dtb=\$fdtfile'
+ca16=config_omap4
+setenv c16 "run config_omap4; run showdefs"
+setenv config_omap5 'echo Configuring for omap5;run config_default; u_k_addr=0x88080000; u_ramfs_addr=0x88000000; u_dtb_addr=0x825f0000; skip_dtb=""; pass_dtb=1; u_iodevs="mmc usb"; u_fs="ext4 ext2 fat"; u_boot=bootz; u_devpart="0:3 0:2 0:1"; u_extraargs="\$u_extraargs console=ttyO2,115200n8"; u_dir="/boot/ /"; setenv fdt_high 0x84000000; run findfdt; u_dtb=\$fdtfile'
+ca17=config_omap5
+setenv c17 "run config_omap5; run showdefs"
 setenv config_omap3-beagle-xm 'echo Configuring for omap3-beagle-xm;run config_omap3; u_dtb=omap3-beagle-xm.dtb'
-ca17=config_omap3-beagle-xm
-setenv c17 "run config_omap3-beagle-xm; run showdefs"
+ca18=config_omap3-beagle-xm
+setenv c18 "run config_omap3-beagle-xm; run showdefs"
 setenv config_omap3-beagle 'echo Configuring for omap3-beagle;run config_omap3; u_dtb=omap3-beagle.dtb'
-ca18=config_omap3-beagle
-setenv c18 "run config_omap3-beagle; run showdefs"
+ca19=config_omap3-beagle
+setenv c19 "run config_omap3-beagle; run showdefs"
 
 if test -n $soc; then
   if test $soc = tegra2; then
@@ -84,13 +88,23 @@
   elif test $soc = omap5; then
     run config_omap5
   fi
+elif test -n $board; then
+  if test $board = cubox-i; then
+    run config_cubox
+  fi
+elif test -n $fdt_file; then
+  if test $fdt_file = imx6q-wandboard.dtb; then
+    run config_wandboard
+  fi
 elif test -n $ethact; then
   if test $ethact = asx0; then
     run config_arndale
   elif test $ethact = FEC0; then
     run config_utilite
-  elif test $ethact = FEC; then
-    run config_wandboard
+  elif test $ethact = egiga0; then
+    if test -n $mvNetConfig || test -n $disaMvPnp; then
+      run config_xp_gp
+    fi
   elif test $ethact = xgmac0; then
     fdt addr 1000
     fdt get value board / compatible
@@ -105,8 +119,6 @@
 elif test -n $beaglerev; then
   run config_omap3
   setenv findfdt 'setenv fdtfile omap3-beagle-xm.dtb; if test $beaglerev = C4; then setenv fdtfile omap3-beagle.dtb; elif test $beaglerev = Cx; then setenv fdtfile omap3-beagle.dtb; fi'
-elif test -n $mvNetConfig || test -n $disaMvPnp; then
-  run config_xp_gp
 elif test -n $panicarg; then
   if test -n $preboot; then
     test 1 = 1
@@ -115,7 +127,7 @@
   fi
 fi
 
-c_count="1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18"
+c_count="1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19"
 
 if test -n $kernel_addr_r; then
   echo Found kernel_addr_r ($kernel_addr_r), using for u_k_addr.