From 0af0cf675dd87d41f893968784458458cdfa1044 Mon Sep 17 00:00:00 2001
From: Neal Gompa <ngompa13@gmail.com>
Date: Mon, 30 May 2016 15:56:24 -0400
Subject: [PATCH 1/4] Update Mageia Cauldron configs for i586 and x86_64

Also, add GPG key from mageia-repos-keys package
---
 etc/mock/mageia-cauldron-i586.cfg   | 19 ++++++++++---------
 etc/mock/mageia-cauldron-x86_64.cfg | 18 ++++++++++--------
 etc/pki/RPM-GPG-KEY-Mageia          | 29 +++++++++++++++++++++++++++++
 3 files changed, 49 insertions(+), 17 deletions(-)
 create mode 100644 etc/pki/RPM-GPG-KEY-Mageia

diff --git a/etc/mock/mageia-cauldron-i586.cfg b/etc/mock/mageia-cauldron-i586.cfg
index cc9af92..93e96aa 100644
--- a/etc/mock/mageia-cauldron-i586.cfg
+++ b/etc/mock/mageia-cauldron-i586.cfg
@@ -23,23 +23,24 @@ syslog_device=
 install_weak_deps=0
 metadata_expire=0
 
-# repos
 
-[mageia-cauldron-core]
+[mageia-cauldron]
 name=Mageia Cauldron - i586
-baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/core/release/
-#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release&arch=i586
+#baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=cauldron&arch=i586@&section=core&repo=release
+mirrorlist=https://www.mageia.org/mirrorlist/?release=cauldron&arch=i586&section=core&repo=release
 gpgcheck=1
-gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/core/release/media_info/pubkey
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
 failovermethod=priority
 enabled=1
 
-[mageia-cauldron-core-debug]
+[mageia-cauldron-debuginfo]
 name=Mageia Cauldron - i586 - Debug
-baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/debug/core/release/
-#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release-debug&arch=i586
+#baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/debug/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=cauldron&arch=i586@&section=core&repo=release&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=cauldron&arch=i586&section=core&repo=release&debug=1
 gpgcheck=1
-gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/debug/core/release/media_info/pubkey
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
 failovermethod=priority
 enabled=0
 
diff --git a/etc/mock/mageia-cauldron-x86_64.cfg b/etc/mock/mageia-cauldron-x86_64.cfg
index 8b6f1de..9916200 100644
--- a/etc/mock/mageia-cauldron-x86_64.cfg
+++ b/etc/mock/mageia-cauldron-x86_64.cfg
@@ -25,21 +25,23 @@ metadata_expire=0
 
 # repos
 
-[mageia-cauldron-core]
+[mageia-cauldron]
 name=Mageia Cauldron - x86_64
-baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/core/release/
-#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release&arch=x86_64
+#baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=cauldron&arch=x86_64@&section=core&repo=release
+mirrorlist=https://www.mageia.org/mirrorlist/?release=cauldron&arch=x86_64&section=core&repo=release
 gpgcheck=1
-gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/core/release/media_info/pubkey
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
 failovermethod=priority
 enabled=1
 
-[mageia-cauldron-core-debug]
+[mageia-cauldron-debuginfo]
 name=Mageia Cauldron - x86_64 - Debug
-baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/debug/core/release/
-#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release-debug&arch=x86_64
+#baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/debug/core/release/
+#metalink=https://mirrors.mageia.org/metalink?distrib=cauldron&arch=x86_64@&section=core&repo=release&debug=true
+mirrorlist=https://www.mageia.org/mirrorlist/?release=cauldron&arch=x86_64&section=core&repo=release&debug=1
 gpgcheck=1
-gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/debug/core/release/media_info/pubkey
+gpgkey=file:///etc/pki/mock/RPM-GPG-KEY-Mageia
 failovermethod=priority
 enabled=0
 
diff --git a/etc/pki/RPM-GPG-KEY-Mageia b/etc/pki/RPM-GPG-KEY-Mageia
new file mode 100644
index 0000000..f6de9fa
--- /dev/null
+++ b/etc/pki/RPM-GPG-KEY-Mageia
@@ -0,0 +1,29 @@
+-----BEGIN PGP PUBLIC KEY BLOCK-----
+Version: GnuPG v1.4.10 (GNU/Linux)
+
+mQINBE1P4SMBEADaT0GrCfaMWjVAdpMCbArG7pIq1F1oWEp1HToSZ5Hbl+gK4WzQ
+t8oJqwIyU7VY4rBeFJ80R6IdzT5yS+IwIbHCuGctABnK+iSLshNQzx5RaV+kYMWZ
+tCnHUQVZzAW2I7pJdeqD9I8TN+Wu223TYyVMMKis+7SPHJjtJzJ8vonIk6Fr0byz
+qcEhwy7TOSrOS5HCumO/k20rp9mtd1clANjA8NjebNqem28WoLlrHgathKaeh0s+
+sq3oClG2ZsbVVbt6yyf46LS1iTboDikeGHY+ujNb+cdqgx46Zb8r3BF/C5UiC8Gd
+c1Dv0kfCP29lTQOwWIJhODn3ylNxcHWGh5yreTak/U2cTQzwHMdtOw7/3TFTDEF+
+qedey+Ipo2FcFhqx+t8gC6DVIfkG4xqwkA+0Q9CWGpHQdHktV1vmYr4pxUnLOMJR
+gKzXNjop20uSHVAH1CyRo3Hx+jKVbGH0vUIfuDTLtDt8mygzPOyUOzhfPTh9zs7t
+19ynBd+lE5AFKbCnlIrX0F11cMnAYppxYE8nYtxPOqkGnA/rLpzlfztxTaqLAe7H
+dmurWTs2NjTgCr1nry3+7id1ruY7Ysr76QaXGxR251ycmxZiPUoMFebtfdPdsw04
+cXpZDKazZhdje2FQL1SDmJaTrF3EDQG6u/MrWiAAMnkEW8UZM/m5fr/gpQARAQAB
+tCVNYWdlaWEgUGFja2FnZXMgPHBhY2thZ2VzQG1hZ2VpYS5vcmc+iQI+BBMBAgAo
+BQJNT+EjAhsvBQkCD1gABgsJCAcDAgYVCAIJCgsEFgIDAQIeAQIXgAAKCRC3QvqL
+gEIPZk/2D/wKGR5bhjH0cEDF9R9/Jf30Xs5s50LT+52hHYoGIENbehhp2YKE7+K2
+J10NLT8XGPrcyhUdu90vXJi4MRD076EnlqQLBVLsEA2yndMQFlEdRfzsQdI+HbR/
+CMLWo5YM+TIZUVMauV1MU15GBN9hyiQc2UQen+zMp96KAnOmNbbQ+71g7XBBOOUd
+P5bDgBLmLlkMAFwVk9tnU93cewOs0qB22ZdL7dTPl/1eXdSUHmatYXBN49ir0pMm
+FhBlZefjVYQ36l9KN8Y51WnB0ErZwd8sDZI4SjSMtDa1JYTHmXGebNt7M8NAB+RL
+fMw7741R8ZixhHYdQZJZ7J2nuZcFnWj65N6fR1coz35KXk+J7+raPYPRhcDBQfw2
+zjarXf3+9MT5Zac02UKr5tkEECUeCmBmCGh+wqZSmxdKKbt3NaxlCZn6HZBXOvm+
+MsT5vP3g9c+34yZV3Eb+bE/7+uTZcDQsoxmh3st340NAOBddcEsJTDt4NSBCJPYn
+8XWo3NUjcL6ocQFYYUMB088kMjsyXTB03d/LG/CHrFfNHdNhQSFFOU3sLPM/X2ES
+/2ojnJ34ClB2d1wFXOKDSlsEqCioB5G7ET6aJ+AFTYt9Od+bJIjqDVmH7Kxi7jS5
+RafapRno7kAqlczO0WN9VgspS5nib2X/Hq7KWQYYLqyy2WIDRRpbOg==
+=5bqr
+-----END PGP PUBLIC KEY BLOCK-----
-- 
2.5.5