From dd5c11eee2eb226a6219291912f19768e45813ea Mon Sep 17 00:00:00 2001
From: Bryan Kearney <bkearney@redhat.com>
Date: Fri, 18 Jun 2010 09:45:24 -0400
Subject: [PATCH] Move to resteasy 2.0-beta-4

---
 client/java/buildfile  |    7 ++-----
 client/java/client.bat |    2 +-
 client/java/client.sh  |    2 +-
 proxy/buildfile        |    7 +++----
 4 files changed, 7 insertions(+), 11 deletions(-)

diff --git a/client/java/buildfile b/client/java/buildfile
index 02e6476..d6f5f22 100644
--- a/client/java/buildfile
+++ b/client/java/buildfile
@@ -14,13 +14,10 @@ COPYRIGHT = ""
 
 RESTEASY = [group('jaxrs-api', 
                   'resteasy-jaxrs',
-                  'resteasy-jaxb-provider', 
                   'resteasy-jackson-provider', 
-                  'resteasy-guice', 
                   :under => 'org.jboss.resteasy',
-                  :version => '1.2.1.GA'), 
+                  :version => '2.0-beta-4'),
             'javax.persistence:persistence-api:jar:1.0',
-            'xalan:xalan:jar:2.6.0',
             'org.scannotation:scannotation:jar:1.0.2',
             'commons-httpclient:commons-httpclient:jar:3.1',
              'org.slf4j:slf4j-api:jar:1.5.8',
@@ -59,7 +56,7 @@ BOUNCYCASTLE = group('bcprov-jdk16', 'bcpg-jdk16', :under=>'org.bouncycastle', :
 #
 # Specify Maven 2.0 remote repositories here, like this:
 repositories.remote << "http://www.ibiblio.org/maven2/"
-repositories.remote << "http://repository.jboss.com/maven2/"
+repositories.remote << "http://repository.jboss.org/nexus/content/groups/public/"
 repositories.remote << "http://gettext-commons.googlecode.com/svn/maven-repository/"
 
 #############################################################################
diff --git a/client/java/client.bat b/client/java/client.bat
index 3207bd9..a12a175 100644
--- a/client/java/client.bat
+++ b/client/java/client.bat
@@ -1,4 +1,4 @@
 @echo OFF
-SET CLASSPATH=target/candlepin-client-0.4.jar;libs/commons-beanutils-1.7.0.jar;libs/commons-codec-1.4.jar;libs/commons-cli-1.2.jar;libs/commons-pool-1.2.jar;libs/commons-collections-3.1.jar;libs/commons-io-1.3.2.jar;libs/commons-logging-1.1.1.jar;libs/commons-lang-2.5.jar;libs/jaxrs-api-1.2.1.GA.jar;libs/resteasy-jaxrs-1.2.1.GA.jar;libs/resteasy-jaxb-provider-1.2.1.GA.jar;libs/resteasy-jackson-provider-1.2.1.GA.jar;libs/resteasy-guice-1.2.1.GA.jar;libs/persistence-api-1.0.jar;libs/xalan-2.6.0.jar;libs/scannotation-1.0.2.jar;libs/commons-httpclient-3.1.jar;libs/slf4j-api-1.5.8.jar;libs/slf4j-simple-1.5.8.jar;libs/freemarker-2.3.15.jar;libs/junit-4.5.jar;libs/mockito-all-1.8.1.jar;libs/log4j-1.2.14.jar;libs/bcprov-jdk16-1.44.jar;libs/bcpg-jdk16-1.44.jar;libs/jdom-1.0.jar;libs/dom4j-1.6.1.jar;libs/gettext-commons-0.9.6.jar;libs/jackson-core-lgpl-1.4.1.jar;libs/jackson-mapper-lgpl-1.4.1.jar;libs/jackson-jaxrs-1.4.1.jar;
+SET CLASSPATH=target/candlepin-client-0.4.jar;libs/commons-beanutils-1.7.0.jar;libs/commons-codec-1.4.jar;libs/commons-cli-1.2.jar;libs/commons-pool-1.2.jar;libs/commons-collections-3.1.jar;libs/commons-io-1.3.2.jar;libs/commons-logging-1.1.1.jar;libs/commons-lang-2.5.jar;libs/jaxrs-api-2.0-beta-4.jar;libs/resteasy-jaxrs-2.0-beta-4.jar;libs/resteasy-jaxb-provider-2.0-beta-4.jar;libs/resteasy-jackson-provider-2.0-beta-4.jar;libs/resteasy-guice-2.0-beta-4.jar;libs/persistence-api-1.0.jar;libs/xalan-2.6.0.jar;libs/scannotation-1.0.2.jar;libs/commons-httpclient-3.1.jar;libs/slf4j-api-1.5.8.jar;libs/slf4j-simple-1.5.8.jar;libs/freemarker-2.3.15.jar;libs/junit-4.5.jar;libs/mockito-all-1.8.1.jar;libs/log4j-1.2.14.jar;libs/bcprov-jdk16-1.44.jar;libs/bcpg-jdk16-1.44.jar;libs/jdom-1.0.jar;libs/dom4j-1.6.1.jar;libs/gettext-commons-0.9.6.jar;libs/jackson-core-lgpl-1.4.1.jar;libs/jackson-mapper-lgpl-1.4.1.jar;libs/jackson-jaxrs-1.4.1.jar;
 
 java -classpath %CLASSPATH% org.fedoraproject.candlepin.client.CLIMain %*
\ No newline at end of file
diff --git a/client/java/client.sh b/client/java/client.sh
index 391bbfb..0c703cc 100755
--- a/client/java/client.sh
+++ b/client/java/client.sh
@@ -1,7 +1,7 @@
 # ENV Variables
 CANDLEPIN_HOME=`dirname $0`
 M2_REPO=$HOME/.m2/repository
-cp_entries=( $CANDLEPIN_HOME/target/candlepin-client-0.4.jar $M2_REPO/commons-beanutils/commons-beanutils/1.7.0/commons-beanutils-1.7.0.jar $M2_REPO/commons-codec/commons-codec/1.4/commons-codec-1.4.jar $M2_REPO/commons-cli/commons-cli/1.2/commons-cli-1.2.jar $M2_REPO/commons-pool/commons-pool/1.2/commons-pool-1.2.jar $M2_REPO/commons-collections/commons-collections/3.1/commons-collections-3.1.jar $M2_REPO/commons-io/commons-io/1.3.2/commons-io-1.3.2.jar $M2_REPO/commons-logging/commons-logging/1.1.1/commons-logging-1.1.1.jar $M2_REPO/commons-lang/commons-lang/2.5/commons-lang-2.5.jar $M2_REPO/org/jboss/resteasy/jaxrs-api/1.2.1.GA/jaxrs-api-1.2.1.GA.jar $M2_REPO/org/jboss/resteasy/resteasy-jaxrs/1.2.1.GA/resteasy-jaxrs-1.2.1.GA.jar $M2_REPO/org/jboss/resteasy/resteasy-jaxb-provider/1.2.1.GA/resteasy-jaxb-provider-1.2.1.GA.jar $M2_REPO/org/jboss/resteasy/resteasy-jackson-provider/1.2.1.GA/resteasy-jackson-provider-1.2.1.GA.jar $M2_REPO/org/jboss/resteasy/resteasy-guice/1.2.1.GA/resteasy-guice-1.2.1.GA.jar $M2_REPO/javax/persistence/persistence-api/1.0/persistence-api-1.0.jar $M2_REPO/xalan/xalan/2.6.0/xalan-2.6.0.jar $M2_REPO/org/scannotation/scannotation/1.0.2/scannotation-1.0.2.jar $M2_REPO/commons-httpclient/commons-httpclient/3.1/commons-httpclient-3.1.jar $M2_REPO/org/slf4j/slf4j-api/1.5.8/slf4j-api-1.5.8.jar $M2_REPO/org/slf4j/slf4j-log4j12/1.5.8/slf4j-log4j12-1.5.8.jar $M2_REPO/org/freemarker/freemarker/2.3.15/freemarker-2.3.15.jar $M2_REPO/junit/junit/4.5/junit-4.5.jar $M2_REPO/org/mockito/mockito-all/1.8.1/mockito-all-1.8.1.jar $M2_REPO/log4j/log4j/1.2.14/log4j-1.2.14.jar $M2_REPO/org/bouncycastle/bcprov-jdk16/1.44/bcprov-jdk16-1.44.jar $M2_REPO/org/bouncycastle/bcpg-jdk16/1.44/bcpg-jdk16-1.44.jar $M2_REPO/jdom/jdom/1.0/jdom-1.0.jar $M2_REPO/dom4j/dom4j/1.6.1/dom4j-1.6.1.jar $M2_REPO/org/xnap/commons/gettext-commons/0.9.6/gettext-commons-0.9.6.jar $M2_REPO/org/codehaus/jackson/jackson-core-lgpl/1.4.1/jackson-core-lgpl-1.4.1.jar $M2_REPO/org/codehaus/jackson/jackson-mapper-lgpl/1.4.1/jackson-mapper-lgpl-1.4.1.jar $M2_REPO/org/codehaus/jackson/jackson-jaxrs/1.4.1/jackson-jaxrs-1.4.1.jar  )
+cp_entries=( $CANDLEPIN_HOME/target/candlepin-client-0.4.jar $M2_REPO/commons-beanutils/commons-beanutils/1.7.0/commons-beanutils-1.7.0.jar $M2_REPO/commons-codec/commons-codec/1.4/commons-codec-1.4.jar $M2_REPO/commons-cli/commons-cli/1.2/commons-cli-1.2.jar $M2_REPO/commons-pool/commons-pool/1.2/commons-pool-1.2.jar $M2_REPO/commons-collections/commons-collections/3.1/commons-collections-3.1.jar $M2_REPO/commons-io/commons-io/1.3.2/commons-io-1.3.2.jar $M2_REPO/commons-logging/commons-logging/1.1.1/commons-logging-1.1.1.jar $M2_REPO/commons-lang/commons-lang/2.5/commons-lang-2.5.jar $M2_REPO/org/jboss/resteasy/jaxrs-api/2.0-beta-4/jaxrs-api-2.0-beta-4.jar $M2_REPO/org/jboss/resteasy/resteasy-jaxrs/2.0-beta-4/resteasy-jaxrs-2.0-beta-4.jar $M2_REPO/org/jboss/resteasy/resteasy-jaxb-provider/2.0-beta-4/resteasy-jaxb-provider-2.0-beta-4.jar $M2_REPO/org/jboss/resteasy/resteasy-jackson-provider/2.0-beta-4/resteasy-jackson-provider-2.0-beta-4.jar $M2_REPO/org/jboss/resteasy/resteasy-guice/2.0-beta-4/resteasy-guice-2.0-beta-4.jar $M2_REPO/javax/persistence/persistence-api/1.0/persistence-api-1.0.jar $M2_REPO/xalan/xalan/2.6.0/xalan-2.6.0.jar $M2_REPO/org/scannotation/scannotation/1.0.2/scannotation-1.0.2.jar $M2_REPO/commons-httpclient/commons-httpclient/3.1/commons-httpclient-3.1.jar $M2_REPO/org/slf4j/slf4j-api/1.5.8/slf4j-api-1.5.8.jar $M2_REPO/org/slf4j/slf4j-log4j12/1.5.8/slf4j-log4j12-1.5.8.jar $M2_REPO/org/freemarker/freemarker/2.3.15/freemarker-2.3.15.jar $M2_REPO/junit/junit/4.5/junit-4.5.jar $M2_REPO/org/mockito/mockito-all/1.8.1/mockito-all-1.8.1.jar $M2_REPO/log4j/log4j/1.2.14/log4j-1.2.14.jar $M2_REPO/org/bouncycastle/bcprov-jdk16/1.44/bcprov-jdk16-1.44.jar $M2_REPO/org/bouncycastle/bcpg-jdk16/1.44/bcpg-jdk16-1.44.jar $M2_REPO/jdom/jdom/1.0/jdom-1.0.jar $M2_REPO/dom4j/dom4j/1.6.1/dom4j-1.6.1.jar $M2_REPO/org/xnap/commons/gettext-commons/0.9.6/gettext-commons-0.9.6.jar $M2_REPO/org/codehaus/jackson/jackson-core-lgpl/1.4.1/jackson-core-lgpl-1.4.1.jar $M2_REPO/org/codehaus/jackson/jackson-mapper-lgpl/1.4.1/jackson-mapper-lgpl-1.4.1.jar $M2_REPO/org/codehaus/jackson/jackson-jaxrs/1.4.1/jackson-jaxrs-1.4.1.jar  )
 
 for entry in ${cp_entries[@]}
 do
diff --git a/proxy/buildfile b/proxy/buildfile
index 53357bb..e9c9478 100644
--- a/proxy/buildfile
+++ b/proxy/buildfile
@@ -19,9 +19,8 @@ RESTEASY = [group('jaxrs-api',
                   'resteasy-guice', 
                   'resteasy-atom-provider',
                   :under => 'org.jboss.resteasy',
-                  :version => '1.2.1.GA'), 
+                  :version => '2.0-beta-4'),
             'javax.persistence:persistence-api:jar:1.0',
-            'xalan:xalan:jar:2.6.0',
             'org.scannotation:scannotation:jar:1.0.2',
             'commons-httpclient:commons-httpclient:jar:3.1']
 
@@ -30,7 +29,7 @@ JACKSON = [group('jackson-core-lgpl',
                  'jackson-jaxrs',
                  'jackson-xc',
                  :under => 'org.codehaus.jackson',
-                 :version => '1.5.2')]
+                 :version => '1.5.3')]
 SUN_JAXB = 'com.sun.xml.bind:jaxb-impl:jar:2.1.12'
 JUNIT = ['junit:junit:jar:4.5', 'org.mockito:mockito-all:jar:1.8.1']
 LOG4J = 'log4j:log4j:jar:1.2.14'
@@ -91,7 +90,7 @@ SCHEMASPY = 'net.sourceforge:schemaSpy:jar:4.1.1'
 #
 # Specify Maven 2.0 remote repositories here, like this:
 repositories.remote << "http://www.ibiblio.org/maven2/"
-repositories.remote << "http://repository.jboss.com/maven2/"
+repositories.remote << "http://repository.jboss.org/nexus/content/groups/public/"
 repositories.remote << "http://gettext-commons.googlecode.com/svn/maven-repository/"
 
 #############################################################################
-- 
1.6.6.1