From: Marcelo Moreira de Mello <mmello@redhat.com>
Date: Tue, 14 Jun 2011 11:37:42 -0300
Subject: [PATCH]  713164: fixes some strange phrases on pt_BR translation

---
 po/pt_BR.po |   96 ++++++++++++++++++++++++++---------------------------------
 1 files changed, 42 insertions(+), 54 deletions(-)

diff --git a/po/pt_BR.po b/po/pt_BR.po
index e8e891d..84feabe 100644
--- a/po/pt_BR.po
+++ b/po/pt_BR.po
@@ -167,15 +167,15 @@ msgstr "opção %s: escolha errada: %r (escolha a partir do %s)"
 #. default options
 #: ../src/subscription_manager/i18n_optparse.py:60
 msgid "show this help message and exit"
-msgstr "apresenta esta mensagem de ajuda e encerramento"
+msgstr "apresenta esta mensagem de ajuda e encerra"
 
 #: ../src/subscription_manager/i18n_optparse.py:61
 msgid "show program's version number and exit"
-msgstr "o número de versão do programa apresentado e encerramento"
+msgstr "o número de versão do programa apresentado e encerra"
 
 #: ../src/subscription_manager/factlib.py:77
 msgid "Updating facts"
-msgstr "Atualização de dados"
+msgstr "Atualizando dados"
 
 #: ../src/subscription_manager/managercli.py:50
 #: ../src/subscription_manager/gui/utils.py:49
@@ -183,7 +183,7 @@ msgid ""
 "Network error, unable to connect to server. Please see /var/log/rhsm/rhsm."
 "log for more information."
 msgstr ""
-"Erro na rede, não foi possível conectar ao servidor. Por favor consulte /var/"
+"Erro na conexão, não foi possível conectar ao servidor. Por favor consulte /var/"
 "log/rhsm/rhsm.log para maiores informações."
 
 #. NOTE: yes this looks a lot like the socket error, but I think these
@@ -194,7 +194,7 @@ msgid ""
 "Network error. Please check the connection details, or see /var/log/rhsm/"
 "rhsm.log for more information."
 msgstr ""
-"Erro na rede. Por favor verifique os detalhes de conexão ou consulte /var/"
+"Erro na conexão. Por favor verifique os detalhes de conexão ou consulte /var/"
 "log/rhsm/rhsm.log para maiores informações."
 
 #. This is what happens when there's an issue with the server on the other side of the wire
@@ -241,7 +241,7 @@ msgstr ""
 
 #: ../src/subscription_manager/managercli.py:193
 msgid "Consumer certificates corrupted. Please reregister."
-msgstr "Certificados corrompidos de cliente. Por favor registre-o novamente."
+msgstr "Certificados do cliente corrompidos. Por favor registre-o novamente."
 
 #: ../src/subscription_manager/managercli.py:210
 msgid "specify a username"
@@ -286,16 +286,16 @@ msgstr ""
 
 #: ../src/subscription_manager/managercli.py:293
 msgid "request a new identity certficate for this machine"
-msgstr "solicitação de uma nova identidade para esta máquina"
+msgstr "solicitar uma nova identidade para esta máquina"
 
 #: ../src/subscription_manager/managercli.py:300
 msgid "request a new certificate be generated"
-msgstr "solicita um novo certificado a ser gerado"
+msgstr "solicitar um novo certificado a ser gerado"
 
 #: ../src/subscription_manager/managercli.py:302
 msgid "force certificate regeneration (requires username and password)"
 msgstr ""
-"força a geração novamente do certificado (requer nome do usuário e senha)"
+"forçar a geração novamente do certificado (requer nome do usuário e senha)"
 
 #: ../src/subscription_manager/managercli.py:307
 msgid ""
@@ -326,11 +326,11 @@ msgstr "registra o cliente ao RHN"
 
 #: ../src/subscription_manager/managercli.py:358
 msgid "the type of consumer to register. Defaults to system"
-msgstr "o tipo de cliente a ser registrado. Padroniza ao sistema"
+msgstr "o tipo de cliente a ser registrado. Padrão: sistema"
 
 #: ../src/subscription_manager/managercli.py:360
 msgid "name of the consumer to register. Defaults to the hostname."
-msgstr "nome do cliente a ser registrado. Padroniza ao hostname."
+msgstr "nome do cliente a ser registrado. Padrão: hostname."
 
 #: ../src/subscription_manager/managercli.py:362
 msgid "register to an existing consumer"
@@ -343,7 +343,7 @@ msgid ""
 "compatible subscriptions."
 msgstr ""
 "subscreve automaticamente este sistema "
-"para                                     subscrições compatíveis."
+"em subscrições compatíveis."
 
 #: ../src/subscription_manager/managercli.py:367
 msgid "register the system even if it is already registered"
@@ -351,11 +351,11 @@ msgstr "registra o sistema mesmo que ele já tenha sido registrado"
 
 #: ../src/subscription_manager/managercli.py:372
 msgid "This system is already registered. Use --force to override"
-msgstr "Este sistema já foi registrado. Use --force para substituição"
+msgstr "Este sistema já foi registrado. Use --force para substituir"
 
 #: ../src/subscription_manager/managercli.py:375
 msgid "Error: consumer name can not be empty."
-msgstr "Erro: o nome do cliente não pode aparecer vazio."
+msgstr "Erro: o nome do cliente não pode ser vazio."
 
 #: ../src/subscription_manager/managercli.py:409
 #, python-format
@@ -543,7 +543,7 @@ msgid ""
 "using this option."
 msgstr ""
 "Erro: Você precisa registrar este sistema pela execução do comando "
-"`registrar` antes de usar esta opção."
+"`register` antes de usar esta opção."
 
 #: ../src/subscription_manager/constants.py:25
 #, python-format
@@ -696,7 +696,7 @@ msgstr "Erro na leitura de informação da Interface net:"
 
 #: ../src/subscription_manager/certmgr.py:89
 msgid "Updating Red Hat certificates & repositories"
-msgstr "Atualização dos repositórios e certificados da Red Hat"
+msgstr "Atualizando os repositórios e certificados da Red Hat"
 
 #: ../src/subscription_manager/certmgr.py:107
 msgid "Unable to update Red Hat certificates & repositories"
@@ -791,7 +791,7 @@ msgstr "Insira o nome no sistema."
 
 #: ../src/subscription_manager/gui/managergui.py:524
 msgid "You must enter a login."
-msgstr "Adicione um logon. "
+msgstr "Adicione um usuário. "
 
 #: ../src/subscription_manager/gui/managergui.py:530
 msgid "You must enter a password."
@@ -1014,7 +1014,7 @@ msgstr ""
 "#-#-#-#-#  pt_BR.po (pt_BR)  #-#-#-#-#\n"
 "<b>Subscrição:</b>\n"
 "#-#-#-#-#  pt_BR.po (pt_BR)  #-#-#-#-#\n"
-"<b>Subscrição:</b> >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+"<b>Subscrição:</b>\n"
 
 #: ../src/subscription_manager/gui/data/installed.glade.h:5
 #: ../src/subscription_manager/gui/data/mainwindow.glade.h:4
@@ -1033,13 +1033,12 @@ msgstr "Próxima Atualização:"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:1
 msgid "<b>HTTP Proxy</b>"
-msgstr "<b>HTTP Proxy</b> >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+msgstr "<b>HTTP Proxy</b>"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:2
 msgid "<small><b>Example:</b> squid.example.com:3128</small>"
 msgstr ""
-"<small><b>Exemplo:</b> squid.example.com:3128</small> >>>>> Contexto "
-"inserido pelo KBabel, não traduza:yes"
+"<small><b>Exemplo:</b> squid.example.com:3128</small>"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:3
 msgid "Advanced Network Configuration"
@@ -1060,8 +1059,7 @@ msgstr "Insira no formato hostname(:port)"
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:7
 msgid "I would like to connect to Red Hat Network via an _HTTP proxy."
 msgstr ""
-"Eu quero conectar-me ao Red Hat Network através de um _HTTP proxy. >>>>> "
-"Contexto inserido pelo KBabel, não traduza:yes"
+"Eu quero conectar-me ao Red Hat Network através de um _HTTP proxy."
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:8
 msgid "Password Text"
@@ -1077,31 +1075,30 @@ msgstr "Texto de Localização do Proxy"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:11
 msgid "Proxy P_assword:"
-msgstr "S_enha Proxy: >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+msgstr "S_enha Proxy:"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:12
 msgid "Proxy _Username:"
 msgstr ""
-"_Nome do Usuário Proxy: >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+"_Nome do Usuário Proxy:"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:13
 msgid "Use Au_thentication with HTTP Proxy:"
 msgstr ""
-"Usa uma Au_tenticação com o HTTP Proxy: >>>>> Contexto inserido pelo KBabel, "
-"não traduza:yes"
+"Usar HTTP Proxy Au_tenticado:"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:14
 msgid "Username Text"
-msgstr "Texto do Nome do Usuário"
+msgstr "Nome do Usuário"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:15
 msgid "_Close"
-msgstr "_Encerra >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+msgstr "_Fechar"
 
 #: ../src/subscription_manager/gui/data/networkConfig.glade.h:16
 msgid "_Proxy Location:"
 msgstr ""
-"Localização do _Proxy: >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+"Endereço do _Proxy:"
 
 #: ../src/subscription_manager/gui/data/compliance.glade.h:1
 msgid "A different date:"
@@ -1125,7 +1122,7 @@ msgstr ""
 "#-#-#-#-#  pt_BR.po (pt_BR)  #-#-#-#-#\n"
 "Subscrever\n"
 "#-#-#-#-#  pt_BR.po (pt_BR)  #-#-#-#-#\n"
-"Subscrever >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+"Subscrever\n"
 
 #: ../src/subscription_manager/gui/data/compliance.glade.h:5
 msgid "Subscription Action Area"
@@ -1206,7 +1203,7 @@ msgstr "Atualizar"
 
 #: ../src/subscription_manager/gui/data/compliance.glade.h:24
 msgid "subscribe button"
-msgstr "botão da subscrição"
+msgstr "botão para subscrever"
 
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:1
 msgid "<b>Other Available Subscriptions</b>"
@@ -1226,18 +1223,16 @@ msgstr "<b>Subscrições que combinam com seus produtos instalados</b>"
 
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:5
 msgid "Add Subscriptions"
-msgstr "Adição de Subscrições"
+msgstr "Adicionar Subscrições"
 
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:6
 #: ../src/subscription_manager/gui/data/importsub.glade.h:1
 msgid "Certificate _Location:"
-msgstr ""
-"_Localização de Certificado: >>>>> Contexto inserido pelo KBabel, não "
-"traduza:yes"
+msgstr "_Localização do Certificado:"
 
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:7
 msgid "Do not register"
-msgstr "Não registra"
+msgstr "Não registrar"
 
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:8
 #: ../src/subscription_manager/gui/data/mainwindow.glade.h:5
@@ -1252,7 +1247,7 @@ msgstr "Não é compatível"
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:10
 #: ../src/subscription_manager/gui/data/importsub.glade.h:4
 msgid "Provide a Subscription Certificate"
-msgstr "Fornecer um Certificado da Subscrição"
+msgstr "Fornecer o Certificado da Subscrição"
 
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:11
 msgid "Register with Red Hat Entitlement Service"
@@ -1275,9 +1270,8 @@ msgid ""
 "To add a subscription, choose a certificate to import to your subscription "
 "certificate directory."
 msgstr ""
-"Para adicionar uma subscrição, escolha um certificado para importar o seu "
-"diretório de certificado da subscrição. >>>>> Contexto inserido pelo KBabel, "
-"não traduza:yes"
+"Para adicionar uma subscrição, escolha um certificado para importar para o seu "
+"diretório de certificados de subscrição."
 
 #: ../src/subscription_manager/gui/data/rhsm.glade.h:16
 msgid "Update Subscriptions"
@@ -1434,8 +1428,7 @@ msgstr "Gerencie suas Subscrições de Produto"
 msgid ""
 "Choose a certificate to import to your subscription certificate directory."
 msgstr ""
-"Escolha um certificado para importar seu diretório de certificado da "
-"subscrição. >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+"Escolha um certificado para importar para o diretório de certificados de subscrição"
 
 #: ../src/subscription_manager/gui/data/mysubs.glade.h:1
 msgid "My Subscriptions View"
@@ -1463,7 +1456,7 @@ msgstr "Contém o texto:"
 
 #: ../src/subscription_manager/gui/data/allsubs.glade.h:5
 msgid "Do Not Overlap"
-msgstr "Não se sobrepõe"
+msgstr "Não se sobrepõem"
 
 #: ../src/subscription_manager/gui/data/allsubs.glade.h:6
 msgid "Match Installed"
@@ -1505,7 +1498,6 @@ msgstr "<b>Por favor insira os dados abaixo para este sistema:</b>"
 msgid "<b>Please enter your Red Hat Network account information:</b>"
 msgstr ""
 "<b>Por favor insira a informação de sua conta do Red hat Network:</b> >>>>> "
-"Contexto inserido pelo KBabel, não traduza:yes"
 
 #: ../src/subscription_manager/gui/data/registration.glade.h:3
 msgid ""
@@ -1524,12 +1516,11 @@ msgstr "Uma etiqueta exclusiva para este sistema"
 
 #: ../src/subscription_manager/gui/data/registration.glade.h:6
 msgid "Password:"
-msgstr "Senha: >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+msgstr "Senha:"
 
 #: ../src/subscription_manager/gui/data/registration.glade.h:7
 msgid "Red Hat Login:"
-msgstr ""
-"Autenticação da Red Hat: >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+msgstr "Red Hat Login:"
 
 #: ../src/subscription_manager/gui/data/registration.glade.h:8
 msgid "Register"
@@ -1566,19 +1557,16 @@ msgstr "Diálogo em Andamento"
 #: ../src/subscription_manager/gui/data/contract_selection.glade.h:1
 msgid "<b>Choose the specific contract to use:</b>"
 msgstr ""
-"<b>Escolha o contrato específico para uso:</b> >>>>> Contexto inserido pelo "
-"KBabel, não traduza:yes"
+"<b>Escolha o contrato específico para uso:</b>"
 
 #: ../src/subscription_manager/gui/data/contract_selection.glade.h:3
 msgid "<b>Total Contracts:</b>"
 msgstr ""
-"<b>Total de Contratos:</b> >>>>> Contexto inserido pelo KBabel, não traduza:"
-"yes"
+"<b>Total de Contratos:</b>"
 
 #: ../src/subscription_manager/gui/data/contract_selection.glade.h:4
 msgid "Contract Selection"
-msgstr ""
-"Seleção de Contrato >>>>> Contexto inserido pelo KBabel, não traduza:yes"
+msgstr "Seleção de Contratos"
 
 #: ../src/subscription_manager/compliance/rhsm_compliance_icon.c:44
 msgid "How often to check for validity (in seconds)"
-- 
1.7.5.2